{
  kml.library.pas
  v1.0
  Medwyn_cz (medwyn@seznam.cz)
  upravy pro primo mikrom
}

var
  List: TStringList;

function ExportExtension: string;
begin
  result := 'KML';
end;

{Tato metoda z retezce odstrani mezery a nahradi je znaky %20 - vhodne pro URL adresy}
function ReplaceSpaces(Spaced: String): String;
begin
Result := ReplaceString(Spaced, ' ', '%20')
end;

{Tato metoda vytvori seznam, do ktereho se budou kategorizovat exportovane body
Zaroven zapise zacatek KML dokumentu}
function ExportHeader: string;
begin
//inicializace seznamu
List := TStringList.Create;

//zacatek KML dokumentu
Result :='<?xml version="1.0" encoding="UTF-8"?>' + CRLF
  + '<kml xmlns="http://www.opengis.net/kml/2.2">' + CRLF
  + '  <Document>' + CRLF
  
  ///////////////////// pro PRIMO ///////////////////////////
  + '  <name>Geocaching</name>' + CRLF
  + '  <metadata><igoicon><filename>Geocaching.bmp</filename></igoicon></metadata>' + CRLF;
  ///////////////////// pro PRIMO ///////////////////////////
end;

{Tato metoda projede seznam, veskere polozky patrici do stejne kategorie(podseznamy)
obali potrebnymi <Folder> tagy, zapise do vysledneho dokumentu a pote ho zakonci}
function ExportFooter: string;
var
  i: Integer;
  j: Integer;
  VnitrniList: TStringList;
begin
  //projedeme List
  for i := 0 to List.Count-1 do
  begin
    //zapiseme jmeno aktualniho vnitrniho listu do <Folder>
    result := result + '    <Folder><name>' + List[i] + '</name>' + CRLF;
    
    ///////////////////// pro PRIMO ///////////////////////////
    result := result + '      <metadata><igoicon><filename>' + List[i] + '.bmp</filename></igoicon></metadata>' + CRLF;
    ///////////////////// pro PRIMO ///////////////////////////
    
    VnitrniList := TStringList(List.Objects[i]);
    //vypiseme obsah aktualniho vnitrniho listu
    for j := 0 to VnitrniList.Count-1 do
    begin
       result := result + VnitrniList[j];
    end;
    //Uzavreme </Folder>
    result := result + '    </Folder>' + CRLF;  
  end;
  //konec KML dokumentu
  result := result + '  </Document>' + CRLF + '</kml>' + CRLF;
end;

{Tato metoda zarazuje predany wText do kategorie predane wCategory. Pokud takova
kategorie jeste neexistuje, zalozi novou. Pokud existuje, prida na konec.}
procedure CategorizePoint(wCategory, wText : String);
var
  Categorized : boolean;
  i: Integer;
  VnitrniList: TStringList;
begin
   Categorized := false;
   for i := 0 to List.Count-1 do
   begin
      if List[i] = wCategory then
      begin
         VnitrniList := TStringList(List.Objects[i]);
         VnitrniList.add(wText);
         Categorized := true;
      end
   end;
   if not Categorized then
   begin
      VnitrniList := TStringList.Create;
      VnitrniList.Add(wText);
      List.AddObject(wCategory,VnitrniList);
   end
end;


{Tato metoda vytvori String strukturovany jako kus KML dokumentu. 
Styl ikon a popisek se nastavuje pouze pokud je predana hodnota wIconUrl s 
nenulovou delkou. Na konci zpracovani zavola metodu CategorizePoint}
procedure ProcessPoint(wCategory,wName,wDescription,wIconUrl,wLat,wLon: String);
var
   Text: String;
begin
  Text := 
  + '      <Placemark>' + CRLF
  + '        <name>' + CDATA(wName) + '</name>' + CRLF
  + '        <description>' + CDATA(wDescription) + '</description>' + CRLF      
  + '        <Point>' + CRLF
  + '          <coordinates>' + wLon + ',' + wLat + ',0</coordinates>' + CRLF
  + '        </Point>' + CRLF;
  if Length(wIconUrl) <> 0 then
  begin
  Text := Text
  + '        <Style>' + CRLF
  + '          <IconStyle>' + CRLF
  + '            <scale>0.6</scale>' + CRLF //zde lze zmnit velikost ikon v GGE
  + '            <Icon>' + CRLF
  + '              <href>' + ReplaceSpaces(wIconUrl) + '</href>' + CRLF 
  + '            </Icon>' + CRLF
  + '          </IconStyle>' + CRLF
  + '          <LabelStyle>' + CRLF
  + '            <scale>0.0</scale>' + CRLF //zde lze zmnit velikost popisek v GGE
  + '          </LabelStyle>' + CRLF
  + '        </Style>' + CRLF;
  end;
  Text := Text
  + '      </Placemark>' + CRLF;
  CategorizePoint(wCategory, Text);
end;
